diff --git a/tools/winebuild/spec32.c b/tools/winebuild/spec32.c
index cecb182b9de..f3ee846dae5 100644
--- a/tools/winebuild/spec32.c
+++ b/tools/winebuild/spec32.c
@@ -603,6 +603,7 @@ void output_module( DLLSPEC *spec )
     unsigned int nb_sections = 2;
 
     if (has_exports) nb_sections++;
+    if (has_imports()) nb_sections++;
 
     /* Reserve some space for the PE header */
 
@@ -797,6 +798,23 @@ void output_module( DLLSPEC *spec )
                 /* CNT_INITIALIZED_DATA|MEM_READ */ );
     }
 
+    if (has_imports())
+    {
+        /* .idata section */
+        output( "\t.ascii \".idata\"\n" );                 /* Name */
+        output( "\t.align 8, 0\n" );
+        output_size( ".L__wine_spec_idata" );            /* VirtualSize */
+        output_rva( "%s", ".L__wine_spec_idata" );       /* VirtualAddress */
+        output_size( ".L__wine_spec_idata" );            /* SizeOfRawData */
+        output_rva( "%s", ".L__wine_spec_idata" );       /* PointerToRawData */
+        output( "\t.long 0\n" );                           /* PointerToRelocations */
+        output( "\t.long 0\n" );                           /* PointerToLinenumbers */
+        output( "\t.short 0\n" );                          /* NumberOfRelocations */
+        output( "\t.short 0\n" );                          /* NumberOfLinenumbers */
+        output( "\t.long 0xc0000040\n"                     /* Characteristics */
+                /* CNT_INITIALIZED_DATA|MEM_READ|MEM_WRITE */ );
+    }
+
     output( "\t.align %u, 0\n", page_size );
     output( "\t.L__wine_spec_pe_end:\n" );
 }
@@ -815,6 +833,7 @@ void output_spec32_file( DLLSPEC *spec )
     output_standard_file_header();
     output_module( spec );
     output_exports( spec );
+    output_imports( spec );
 
     if (target_platform != PLATFORM_WINDOWS)
     {
@@ -828,7 +847,6 @@ void output_spec32_file( DLLSPEC *spec )
     }
 
     output_stubs( spec );
-    output_imports( spec );
     output_relay_data( spec );
     if (needs_get_pc_thunk) output_get_pc_thunk();
     output_resources( spec );
diff --git a/tools/winebuild/utils.c b/tools/winebuild/utils.c
index 5a102d80a1e..bf8e395dcc8 100644
--- a/tools/winebuild/utils.c
+++ b/tools/winebuild/utils.c
@@ -1258,6 +1258,16 @@ const char *get_asm_export_section(void)
     }
 }
 
+const char *get_asm_import_section(void)
+{
+    switch (target_platform)
+    {
+    case PLATFORM_APPLE:   return ".data";
+    case PLATFORM_WINDOWS: return ".section .idata";
+    default:               return ".section .data";
+    }
+}
+
 const char *get_asm_rodata_section(void)
 {
     switch (target_platform)
-- 
2.27.0

>From 668c88b452ab7698910a66a0c38e330aebd64e72 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Thu, 11 Jun 2020 20:16:48 +0200
Subject: [PATCH 16/32] winebuild: Output .rsrc section header.

---
 tools/winebuild/res32.c  |  7 ++++---
 tools/winebuild/spec32.c | 20 +++++++++++++++++++-
 2 files changed, 23 insertions(+), 4 deletions(-)

diff --git a/tools/winebuild/res32.c b/tools/winebuild/res32.c
index bd55bb2fa5c..8e1dca4d534 100644
--- a/tools/winebuild/res32.c
+++ b/tools/winebuild/res32.c
@@ -427,6 +427,7 @@ static inline void output_res_dir( unsigned int nb_names, unsigned int nb_ids )
 /* output the resource definitions */
 void output_resources( DLLSPEC *spec )
 {
+    unsigned int page_size = get_page_size();
     int k, nb_id_types;
     unsigned int i, n;
     struct res_tree *tree;
@@ -442,7 +443,7 @@ void output_resources( DLLSPEC *spec )
 
     output( "\n/* resources */\n\n" );
     output( "\t%s\n", get_asm_rsrc_section() );
-    output( "\t.align %d\n", get_alignment(get_ptr_size()) );
+    output( "\t.align %u, 0\n", page_size );
     output( ".L__wine_spec_resources:\n" );
 
     for (i = nb_id_types = 0, type = tree->types; i < tree->nb_types; i++, type++)
@@ -494,7 +495,7 @@ void output_resources( DLLSPEC *spec )
 
     for (i = 0, res = spec->resources; i < spec->nb_resources; i++, res++)
     {
-        output( "\n\t.align %d\n", get_alignment(4) );
+        output( "\n\t.align %d, 0\n", get_alignment(4) );
         output( ".L__wine_spec_res_%d:\n", i );
         dump_res_data( res );
     }
@@ -502,7 +503,7 @@ void output_resources( DLLSPEC *spec )
     if (target_platform != PLATFORM_WINDOWS)
     {
         output( ".L__wine_spec_resources_end:\n" );
-        output( "\t.byte 0\n" );
+        output( "\t.align %u, 0\n", page_size );
     }
     free_resource_tree( tree );
 }
diff --git a/tools/winebuild/spec32.c b/tools/winebuild/spec32.c
index f3ee846dae5..e7dffa1cb60 100644
--- a/tools/winebuild/spec32.c
+++ b/tools/winebuild/spec32.c
@@ -604,6 +604,7 @@ void output_module( DLLSPEC *spec )
 
     if (has_exports) nb_sections++;
     if (has_imports()) nb_sections++;
+    if (spec->nb_resources) nb_sections++;
 
     /* Reserve some space for the PE header */
 
@@ -815,6 +816,23 @@ void output_module( DLLSPEC *spec )
                 /* CNT_INITIALIZED_DATA|MEM_READ|MEM_WRITE */ );
     }
 
+    if (spec->nb_resources)
+    {
+        /* .rsrc section */
+        output( "\t.ascii \".rsrc\"\n" );              /* Name */
+        output( "\t.align 8, 0\n" );
+        output_size( ".L__wine_spec_resources" );      /* VirtualSize */
+        output_rva( "%s", ".L__wine_spec_resources" ); /* VirtualAddress */
+        output_size( ".L__wine_spec_resources" );      /* SizeOfRawData */
+        output_rva( "%s", ".L__wine_spec_resources" ); /* PointerToRawData */
+        output( "\t.long 0\n" );                       /* PointerToRelocations */
+        output( "\t.long 0\n" );                       /* PointerToLinenumbers */
+        output( "\t.short 0\n" );                      /* NumberOfRelocations */
+        output( "\t.short 0\n" );                      /* NumberOfLinenumbers */
+        output( "\t.long 0xc0000040\n"                 /* Characteristics */
+                /* CNT_INITIALIZED_DATA|MEM_READ|MEM_WRITE */ );
+    }
+
     output( "\t.align %u, 0\n", page_size );
     output( "\t.L__wine_spec_pe_end:\n" );
 }
@@ -834,6 +852,7 @@ void output_spec32_file( DLLSPEC *spec )
     output_module( spec );
     output_exports( spec );
     output_imports( spec );
+    output_resources( spec );
 
     if (target_platform != PLATFORM_WINDOWS)
     {
@@ -849,7 +868,6 @@ void output_spec32_file( DLLSPEC *spec )
     output_stubs( spec );
     output_relay_data( spec );
     if (needs_get_pc_thunk) output_get_pc_thunk();
-    output_resources( spec );
 
     if (target_platform != PLATFORM_WINDOWS)
     {
-- 
2.27.0

>From 9099396f7ce35ecb3d36fde912e1af3a572aae37 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Thu, 18 Jun 2020 02:06:38 +0200
Subject: [PATCH 17/32] winebuild: Output .rodata section header.

---
 tools/winebuild/build.h  |  3 ++
 tools/winebuild/import.c | 17 +++++++-
 tools/winebuild/spec16.c |  2 +
 tools/winebuild/spec32.c | 94 +++++++++++++++++++++++++++++++---------
 4 files changed, 93 insertions(+), 23 deletions(-)

diff --git a/tools/winebuild/build.h b/tools/winebuild/build.h
index f7c010c80a1..a3ed4588f30 100644
--- a/tools/winebuild/build.h
+++ b/tools/winebuild/build.h
@@ -301,10 +301,13 @@ extern void read_undef_symbols( DLLSPEC *spec, char **argv );
 extern void resolve_imports( DLLSPEC *spec );
 extern int is_undefined( const char *name );
 extern int has_imports(void);
+extern int has_stubs( const DLLSPEC *spec );
+extern void output_relay_rodata( DLLSPEC *spec );
 extern void output_relay_data( DLLSPEC *spec );
 extern void output_get_pc_thunk(void);
 extern void output_module( DLLSPEC *spec );
 extern void output_stubs( DLLSPEC *spec );
+extern void output_stubs_rodata( DLLSPEC *spec );
 extern void output_imports( DLLSPEC *spec );
 extern void output_static_lib( DLLSPEC *spec, char **argv );
 extern void output_exports( DLLSPEC *spec );
diff --git a/tools/winebuild/import.c b/tools/winebuild/import.c
index e210b0a360e..63b76038a3d 100644
--- a/tools/winebuild/import.c
+++ b/tools/winebuild/import.c
@@ -457,7 +457,7 @@ static void add_undef_import( const char *name, int is_ordinal )
 }
 
 /* check if the spec file exports any stubs */
-static int has_stubs( const DLLSPEC *spec )
+int has_stubs( const DLLSPEC *spec )
 {
     int i;
     for (i = 0; i < spec->nb_entry_points; i++)
@@ -1373,8 +1373,21 @@ void output_stubs( DLLSPEC *spec )
         output_cfi( ".cfi_endproc" );
         output_function_size( name );
     }
+}
+
+/*******************************************************************
+ *         output_stubs_rodata
+ *
+ * Output the read-only data used by stub entry points
+ */
+void output_stubs_rodata( DLLSPEC *spec )
+{
+    const char *name, *exp_name;
+    int i;
+
+    if (!has_stubs( spec )) return;
 
-    output( "\t%s\n", get_asm_string_section() );
+    output( "\t%s\n", get_asm_rodata_section() );
     output( ".L__wine_spec_file_name:\n" );
     output( "\t%s \"%s\"\n", get_asm_string_keyword(), spec->file_name );
     for (i = 0; i < spec->nb_entry_points; i++)
diff --git a/tools/winebuild/spec16.c b/tools/winebuild/spec16.c
index 1c8cf341402..f66dcfd9192 100644
--- a/tools/winebuild/spec16.c
+++ b/tools/winebuild/spec16.c
@@ -823,7 +823,9 @@ void output_spec16_file( DLLSPEC *spec16 )
     output_module( spec32 );
     output_module16( spec16 );
     output_stubs( spec16 );
+    output_stubs_rodata( spec16 );
     output_exports( spec32 );
+    output_relay_rodata( spec32 );
     output_relay_data( spec32 );
     output_imports( spec16 );
     if (!strcmp( spec16->dll_name, "kernel" )) output_asm_relays16();
diff --git a/tools/winebuild/spec32.c b/tools/winebuild/spec32.c
index e7dffa1cb60..d8677f7517f 100644
--- a/tools/winebuild/spec32.c
+++ b/tools/winebuild/spec32.c
@@ -208,27 +208,6 @@ static void output_relay_debug( DLLSPEC *spec )
 {
     int i;
 
-    /* first the table of entry point offsets */
-
-    output( "\t%s\n", get_asm_rodata_section() );
-    output( "\t.align %d\n", get_alignment(4) );
-    output( ".L__wine_spec_relay_entry_point_offsets:\n" );
-
-    for (i = spec->base; i <= spec->limit; i++)
-    {
-        ORDDEF *odp = spec->ordinals[i];
-
-        if (needs_relay( odp ))
-            output( "\t.long .L__wine_spec_relay_entry_point_%d-__wine_spec_relay_entry_points\n", i );
-        else
-            output( "\t.long 0\n" );
-    }
-
-    /* then the strings of argument types */
-
-    output( ".L__wine_spec_relay_args_string:\n" );
-    output( "\t%s \"%s\"\n", get_asm_string_keyword(), build_args_string( spec ));
-
     /* then the relay thunks */
 
     output( "\t.text\n" );
@@ -565,6 +544,60 @@ void output_exports( DLLSPEC *spec )
 }
 
 
+/*******************************************************************
+ *         output_rodata
+ *
+ * Output the read-only data for a Win32 module.
+ */
+void output_rodata( DLLSPEC *spec )
+{
+    unsigned int page_size = get_page_size();
+
+    output( "\t%s\n", get_asm_rodata_section() );
+    output( "\t.align %d, 0\n", page_size );
+    output( ".L__wine_spec_rodata:\n" );
+
+    if (has_relays( spec ))
+        output_relay_rodata( spec );
+
+    if (has_stubs( spec ))
+        output_stubs_rodata( spec );
+
+    output( ".L__wine_spec_rodata_end:\n" );
+}
+
+
+/*******************************************************************
+ *         output_relay_rodata
+ *
+ * Output the delay read-only data for a Win32 module.
+ */
+void output_relay_rodata( DLLSPEC *spec )
+{
+    int i;
+
+    /* first the table of entry point offsets */
+
+    output( "\t.align %d\n", get_alignment(4) );
+    output( ".L__wine_spec_relay_entry_point_offsets:\n" );
+
+    for (i = spec->base; i <= spec->limit; i++)
+    {
+        ORDDEF *odp = spec->ordinals[i];
+
+        if (needs_relay( odp ))
+            output( "\t.long .L__wine_spec_relay_entry_point_%d-__wine_spec_relay_entry_points\n", i );
+        else
+            output( "\t.long 0\n" );
+    }
+
+    /* then the strings of argument types */
+
+    output( ".L__wine_spec_relay_args_string:\n" );
+    output( "\t%s \"%s\"\n", get_asm_string_keyword(), build_args_string( spec ));
+}
+
+
 /*******************************************************************
  *         output_relay_data
  *
@@ -605,6 +638,7 @@ void output_module( DLLSPEC *spec )
     if (has_exports) nb_sections++;
     if (has_imports()) nb_sections++;
     if (spec->nb_resources) nb_sections++;
+    if ((has_stubs( spec ) || has_relays( spec ))) nb_sections++;
 
     /* Reserve some space for the PE header */
 
@@ -833,6 +867,23 @@ void output_module( DLLSPEC *spec )
                 /* CNT_INITIALIZED_DATA|MEM_READ|MEM_WRITE */ );
     }
 
+    if (has_stubs( spec ) || has_relays( spec ))
+    {
+        /* .rodata section */
+        output( "\t.ascii \".rodata\"\n" );              /* Name */
+        output( "\t.align 8, 0\n" );
+        output_size( ".L__wine_spec_rodata" );         /* VirtualSize */
+        output_rva( "%s", ".L__wine_spec_rodata" );    /* VirtualAddress */
+        output_size( ".L__wine_spec_rodata" );         /* SizeOfRawData */
+        output_rva( "%s", ".L__wine_spec_rodata" );    /* PointerToRawData */
+        output( "\t.long 0\n" );                       /* PointerToRelocations */
+        output( "\t.long 0\n" );                       /* PointerToLinenumbers */
+        output( "\t.short 0\n" );                      /* NumberOfRelocations */
+        output( "\t.short 0\n" );                      /* NumberOfLinenumbers */
+        output( "\t.long 0x40000040\n"                 /* Characteristics */
+                /* CNT_INITIALIZED_DATA|MEM_READ */ );
+    }
+
     output( "\t.align %u, 0\n", page_size );
     output( "\t.L__wine_spec_pe_end:\n" );
 }
@@ -853,6 +904,7 @@ void output_spec32_file( DLLSPEC *spec )
     output_exports( spec );
     output_imports( spec );
     output_resources( spec );
+    output_rodata( spec );
 
     if (target_platform != PLATFORM_WINDOWS)
     {
-- 
2.27.0

>From be0346cd6224be92a3aade89e238b70d513ec840 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Fri, 12 Jun 2020 09:10:55 +0200
Subject: [PATCH 18/32] ntdll: Only relocate module header if necessary.

With a bit of chance, and with -Wl,--image-base tweaking, the so file
can be loaded at the right place and the module headers will not have to
be aligned.
---
 dlls/ntdll/loader.c      |  8 ++++++--
 dlls/ntdll/unix/loader.c | 22 +++++++++++++++++-----
 2 files changed, 23 insertions(+), 7 deletions(-)

diff --git a/dlls/ntdll/loader.c b/dlls/ntdll/loader.c
index 506b9f099ba..f2fec6b0e7e 100644
--- a/dlls/ntdll/loader.c
+++ b/dlls/ntdll/loader.c
@@ -2653,6 +2653,7 @@ static NTSTATUS load_so_dll( LPCWSTR load_path, const UNICODE_STRING *nt_name,
     ANSI_STRING unix_name;
     UNICODE_STRING win_name = *nt_name;
     HMODULE module;
+    BOOL mapped = FALSE;
 
     unix_name.Buffer = NULL;
     info.load_path = load_path;
@@ -2675,7 +2676,10 @@ static NTSTATUS load_so_dll( LPCWSTR load_path, const UNICODE_STRING *nt_name,
 
     prev_info = builtin_load_info;
     builtin_load_info = &info;
-    handle = dlopen( so_name ? so_name : unix_name.Buffer, RTLD_NOW );
+    if ((handle = dlopen( so_name ? so_name : unix_name.Buffer, RTLD_NOW | RTLD_NOLOAD )))
+        mapped = TRUE;
+    else
+        handle = dlopen( so_name ? so_name : unix_name.Buffer, RTLD_NOW );
     builtin_load_info = prev_info;
     RtlFreeHeap( GetProcessHeap(), 0, unix_name.Buffer );
 
@@ -2708,7 +2712,7 @@ static NTSTATUS load_so_dll( LPCWSTR load_path, const UNICODE_STRING *nt_name,
         }
         else
         {
-            if ((info.status = unix_funcs->map_so_dll( nt, module ))) goto failed;
+            if (!mapped && (info.status = unix_funcs->map_so_dll( nt, module ))) goto failed;
             if ((info.status = build_so_dll_module( load_path, &win_name, module, flags, &info.wm )))
                 goto failed;
             TRACE_(loaddll)( "Loaded %s at %p: builtin\n",
diff --git a/dlls/ntdll/unix/loader.c b/dlls/ntdll/unix/loader.c
index 3a8674f94b7..4b825f25947 100644
--- a/dlls/ntdll/unix/loader.c
+++ b/dlls/ntdll/unix/loader.c
@@ -132,6 +132,7 @@ static inline void fixup_rva_ptrs( void *array, BYTE *base, unsigned int count )
 /* fixup an array of RVAs by adding the specified delta */
 static inline void fixup_rva_dwords( DWORD *ptr, int delta, unsigned int count )
 {
+    if (!delta) return;
     for ( ; count; count--, ptr++) if (*ptr) *ptr += delta;
 }
 
@@ -139,6 +140,7 @@ static inline void fixup_rva_dwords( DWORD *ptr, int delta, unsigned int count )
 /* fixup an array of name/ordinal RVAs by adding the specified delta */
 static inline void fixup_rva_names( UINT_PTR *ptr, int delta )
 {
+    if (!delta) return;
     for ( ; *ptr; ptr++) if (!(*ptr & IMAGE_ORDINAL_FLAG)) *ptr += delta;
 }
 
@@ -754,17 +756,27 @@ static NTSTATUS CDECL map_so_dll( const IMAGE_NT_HEADERS *nt_descr, HMODULE modu
     IMAGE_DOS_HEADER *dos;
     IMAGE_NT_HEADERS *nt;
     IMAGE_SECTION_HEADER *sec;
-    BYTE *addr = (BYTE *)module;
+    BYTE *addr = (BYTE *)module, *tmp;
     DWORD code_end;
     int delta;
     unsigned int i;
     DWORD size = nt_descr->OptionalHeader.SizeOfHeaders;
 
-    delta = (const BYTE *)nt_descr->OptionalHeader.ImageBase - addr;
+    if ((delta = (const BYTE *)nt_descr->OptionalHeader.ImageBase - addr))
+    {
+        TRACE("aligning module from %p-%p to %p-%p\n", (const BYTE *)nt_descr->OptionalHeader.ImageBase,
+            (const BYTE *)nt_descr->OptionalHeader.ImageBase + size, (BYTE *)module, (const BYTE *)module + size);
+
+        if ((tmp = wine_anon_mmap( NULL, size, PROT_READ | PROT_WRITE, 0 )) == MAP_FAILED) return STATUS_NO_MEMORY;
+        memmove(tmp, (const BYTE *)nt_descr->OptionalHeader.ImageBase, size);
 
-    if (wine_anon_mmap( addr, size, PROT_READ | PROT_WRITE, MAP_FIXED ) != addr) return STATUS_NO_MEMORY;
+        if (wine_anon_mmap( addr, size, PROT_READ | PROT_WRITE, MAP_FIXED ) != addr) return STATUS_NO_MEMORY;
 
-    memmove(addr, (const BYTE *)nt_descr->OptionalHeader.ImageBase, size);
+        memmove(addr, tmp, size);
+        munmap(tmp, size);
+    }
+    else if (remap_writable( addr, size ))
+        return STATUS_NO_MEMORY;
 
     dos = (IMAGE_DOS_HEADER *)addr;
     nt  = (IMAGE_NT_HEADERS *)((BYTE *)dos + dos->e_lfanew);
@@ -790,7 +802,7 @@ static NTSTATUS CDECL map_so_dll( const IMAGE_NT_HEADERS *nt_descr, HMODULE modu
 
     /* build the NT headers */
 
-    nt->OptionalHeader.ImageBase = (ULONG_PTR)addr;
+    if (delta) nt->OptionalHeader.ImageBase = (ULONG_PTR)addr;
 
     fixup_rva_dwords( &nt->OptionalHeader.AddressOfEntryPoint, delta, 1 );
     fixup_rva_dwords( &nt->OptionalHeader.BaseOfCode, delta, 1 );
-- 
2.27.0

>From 3a4cdd0e04549e570ee416c8a7fb595f144074c8 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Fri, 12 Jun 2020 09:20:59 +0200
Subject: [PATCH 19/32] winebuild: Output module in the reserved region.

With a bit of chance, and with -Wl,--image-base tweaking, the so file
can be loaded at the right place and the module headers will not have to
be aligned.
---
 dlls/ntdll/unix/loader.c |  2 +-
 tools/winebuild/spec32.c | 25 +++++++++----------------
 tools/winebuild/utils.c  | 29 +++++++++++++++++++----------
 3 files changed, 29 insertions(+), 27 deletions(-)

diff --git a/dlls/ntdll/unix/loader.c b/dlls/ntdll/unix/loader.c
index 4b825f25947..df2ebca809b 100644
--- a/dlls/ntdll/unix/loader.c
+++ b/dlls/ntdll/unix/loader.c
@@ -792,7 +792,7 @@ static NTSTATUS CDECL map_so_dll( const IMAGE_NT_HEADERS *nt_descr, HMODULE modu
         fixup_rva_dwords( &sec[i].VirtualAddress, delta, 1 );
         fixup_rva_dwords( &sec[i].PointerToRawData, delta, 1 );
 
-        if (memcmp( sec[i].Name, ".text", sizeof(".text" )) && code_end > sec[i].VirtualAddress)
+        if (!memcmp( sec[i].Name, ".data", sizeof(".data" )))
             code_end = sec[i].VirtualAddress;
 
         if ((sec[i].Characteristics & IMAGE_SCN_CNT_INITIALIZED_DATA) &&
diff --git a/tools/winebuild/spec32.c b/tools/winebuild/spec32.c
index d8677f7517f..9c536bfe912 100644
--- a/tools/winebuild/spec32.c
+++ b/tools/winebuild/spec32.c
@@ -648,16 +648,9 @@ void output_module( DLLSPEC *spec )
         return;  /* nothing to do */
     case PLATFORM_APPLE:
         output( "\t.text\n" );
-        output( "\t.align %d\n", get_alignment(page_size) );
-        output( "\t.globl %s\n", asm_name("__wine_spec_module") );
-        output( "%s:\n", asm_name("__wine_spec_module") );
-        output( "\t.space 65536\n" );
         break;
     case PLATFORM_SOLARIS:
         output( "\n\t.section \".text\",\"ax\"\n" );
-        output( "\t.globl %s\n", asm_name("__wine_spec_module") );
-        output( "%s:\n", asm_name("__wine_spec_module") );
-        output( "\t.skip %u\n", 65536 + page_size );
         break;
     default:
         switch(target_cpu)
@@ -665,29 +658,26 @@ void output_module( DLLSPEC *spec )
         case CPU_x86:
         case CPU_x86_64:
             output( "\n\t.section \".init\",\"ax\"\n" );
-            output( "\tjmp 1f\n" );
+            output( "\tjmp .L__wine_spec_text\n" );
             break;
         case CPU_ARM:
             output( "\n\t.section \".text\",\"ax\"\n" );
-            output( "\tb 1f\n" );
+            output( "\tb .L__wine_spec_text\n" );
             break;
         case CPU_ARM64:
         case CPU_POWERPC:
             output( "\n\t.section \".init\",\"ax\"\n" );
-            output( "\tb 1f\n" );
+            output( "\tb .L__wine_spec_text\n" );
             break;
         }
-        output( "\t.globl %s\n", asm_name("__wine_spec_module") );
-        output( "%s:\n", asm_name("__wine_spec_module") );
-        output( "\t.skip %u\n", 65536 + page_size );
-        output( "1:\n" );
         break;
     }
 
     /* Output the DOS header */
 
-    output( "\n\t.data\n" );
-    output( "\t.align %d\n", get_alignment(get_ptr_size()) );
+    output( "\t.align %u\n", page_size );
+    output( "\t.globl %s\n", asm_name("__wine_spec_module") );
+    output( "%s:\n", asm_name("__wine_spec_module") );
     output( ".L__wine_spec_dos:\n" );
     output( "\t.short 0x5a4d\n" );       /* e_magic */
     output( "\t.short 0x90\n" );         /* e_cblp */
@@ -886,6 +876,9 @@ void output_module( DLLSPEC *spec )
 
     output( "\t.align %u, 0\n", page_size );
     output( "\t.L__wine_spec_pe_end:\n" );
+
+    output( "\t.org %s + 0x10000\n", asm_name("__wine_spec_module") );
+    output_function_size( asm_name("__wine_spec_module") );
 }
 
 
diff --git a/tools/winebuild/utils.c b/tools/winebuild/utils.c
index bf8e395dcc8..74c98c02801 100644
--- a/tools/winebuild/utils.c
+++ b/tools/winebuild/utils.c
@@ -1238,6 +1238,18 @@ const char *get_asm_string_keyword(void)
     }
 }
 
+static const char *get_asm_wine_section(void)
+{
+    switch (target_platform)
+    {
+    case PLATFORM_APPLE:   return ".text";
+    case PLATFORM_SOLARIS: return ".text";
+    default:
+        if (target_cpu == CPU_ARM) return ".section .text";
+        return ".section .init";
+    }
+}
+
 const char *get_asm_data_section(void)
 {
     switch (target_platform)
@@ -1252,9 +1264,8 @@ const char *get_asm_export_section(void)
 {
     switch (target_platform)
     {
-    case PLATFORM_APPLE:   return ".data";
     case PLATFORM_WINDOWS: return ".section .edata";
-    default:               return ".section .data";
+    default: return get_asm_wine_section();
     }
 }
 
@@ -1262,9 +1273,8 @@ const char *get_asm_import_section(void)
 {
     switch (target_platform)
     {
-    case PLATFORM_APPLE:   return ".data";
     case PLATFORM_WINDOWS: return ".section .idata";
-    default:               return ".section .data";
+    default: return get_asm_wine_section();
     }
 }
 
@@ -1272,8 +1282,8 @@ const char *get_asm_rodata_section(void)
 {
     switch (target_platform)
     {
-    case PLATFORM_APPLE: return ".const";
-    default:             return ".section .rodata";
+    case PLATFORM_WINDOWS: return ".section .rodata";
+    default: return get_asm_wine_section();
     }
 }
 
@@ -1281,9 +1291,8 @@ const char *get_asm_rsrc_section(void)
 {
     switch (target_platform)
     {
-    case PLATFORM_APPLE:   return ".data";
     case PLATFORM_WINDOWS: return ".section .rsrc";
-    default:               return ".section .data";
+    default: return get_asm_wine_section();
     }
 }
 
@@ -1291,7 +1300,7 @@ const char *get_asm_string_section(void)
 {
     switch (target_platform)
     {
-    case PLATFORM_APPLE: return ".cstring";
-    default:             return ".section .rodata";
+    case PLATFORM_WINDOWS: return ".section .rodata";
+    default: return get_asm_wine_section();
     }
 }
-- 
2.27.0

>From 927953ba1df3e570be885ea4fd180c14086608dd Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Thu, 18 Jun 2020 01:33:07 +0200
Subject: [PATCH 20/32] winebuild: Output .text section size.

---
 dlls/ntdll/unix/loader.c | 12 ------------
 tools/winebuild/spec32.c | 11 +++++++----
 2 files changed, 7 insertions(+), 16 deletions(-)

diff --git a/dlls/ntdll/unix/loader.c b/dlls/ntdll/unix/loader.c
index df2ebca809b..496beeba913 100644
--- a/dlls/ntdll/unix/loader.c
+++ b/dlls/ntdll/unix/loader.c
@@ -757,7 +757,6 @@ static NTSTATUS CDECL map_so_dll( const IMAGE_NT_HEADERS *nt_descr, HMODULE modu
     IMAGE_NT_HEADERS *nt;
     IMAGE_SECTION_HEADER *sec;
     BYTE *addr = (BYTE *)module, *tmp;
-    DWORD code_end;
     int delta;
     unsigned int i;
     DWORD size = nt_descr->OptionalHeader.SizeOfHeaders;
@@ -785,16 +784,12 @@ static NTSTATUS CDECL map_so_dll( const IMAGE_NT_HEADERS *nt_descr, HMODULE modu
     /* fixup the sections */
 
     fixup_rva_dwords( &nt->OptionalHeader.SizeOfImage, delta, 1 );
-    code_end = nt->OptionalHeader.SizeOfImage;
 
     for (i = 0; i < nt->FileHeader.NumberOfSections; ++i)
     {
         fixup_rva_dwords( &sec[i].VirtualAddress, delta, 1 );
         fixup_rva_dwords( &sec[i].PointerToRawData, delta, 1 );
 
-        if (!memcmp( sec[i].Name, ".data", sizeof(".data" )))
-            code_end = sec[i].VirtualAddress;
-
         if ((sec[i].Characteristics & IMAGE_SCN_CNT_INITIALIZED_DATA) &&
             remap_writable( addr + sec[i].VirtualAddress, sec[i].Misc.VirtualSize ))
             return STATUS_NO_MEMORY;
@@ -809,13 +804,6 @@ static NTSTATUS CDECL map_so_dll( const IMAGE_NT_HEADERS *nt_descr, HMODULE modu
 #ifndef _WIN64
     fixup_rva_dwords( &nt->OptionalHeader.BaseOfData, delta, 1 );
 #endif
-    nt->OptionalHeader.SizeOfCode = code_end - nt->OptionalHeader.BaseOfCode;
-
-    for (i = 0; i < nt->FileHeader.NumberOfSections; ++i)
-    {
-        if (memcmp( sec[i].Name, ".text", sizeof(".text" ))) continue;
-        sec[i].Misc.VirtualSize = sec[i].SizeOfRawData = nt->OptionalHeader.SizeOfCode;
-    }
 
     for (i = 0; i < nt->OptionalHeader.NumberOfRvaAndSizes; i++)
         fixup_rva_dwords( &nt->OptionalHeader.DataDirectory[i].VirtualAddress, delta, 1 );
diff --git a/tools/winebuild/spec32.c b/tools/winebuild/spec32.c
index 9c536bfe912..d3b6062175e 100644
--- a/tools/winebuild/spec32.c
+++ b/tools/winebuild/spec32.c
@@ -143,7 +143,10 @@ static void get_arg_string( ORDDEF *odp, char str[MAX_ARGUMENTS + 1] )
 
 static void output_size( const char *name )
 {
-    output( "\t.long %s_end - %s\n", name, name );
+    if (!strcmp(name, ".L__wine_spec_text"))
+        output( "\t.long %s - %s\n", asm_name("etext"), name );
+    else
+        output( "\t.long %s_end - %s\n", name, name );
 }
 
 static void output_data_directories( const char *names[16] )
@@ -738,7 +741,7 @@ void output_module( DLLSPEC *spec )
              get_ptr_size() == 8 ? IMAGE_NT_OPTIONAL_HDR64_MAGIC : IMAGE_NT_OPTIONAL_HDR32_MAGIC );
     output( "\t.byte 7\n" );              /* MajorLinkerVersion */
     output( "\t.byte 10\n" );             /* MinorLinkerVersion */
-    output( "\t.long 0\n" );              /* SizeOfCode */
+    output_size( ".L__wine_spec_text" );  /* SizeOfCode */
     output_size( ".L__wine_spec_data" );  /* SizeOfInitializedData */
     output( "\t.long 0\n" );              /* SizeOfUninitializedData */
     output_rva( spec->init_func ?         /* AddressOfEntryPoint */
@@ -781,9 +784,9 @@ void output_module( DLLSPEC *spec )
     /* .text section */
     output( "\t.ascii \".text\"\n" );                  /* Name */
     output( "\t.align 8, 0\n" );
-    output( "\t.long 0\n" );                           /* VirtualSize */
+    output_size( ".L__wine_spec_text" );               /* VirtualSize */
     output_rva( "%s", ".L__wine_spec_text" );          /* VirtualAddress */
-    output( "\t.long 0\n" );                           /* SizeOfRawData */
+    output_size( ".L__wine_spec_text" );               /* SizeOfRawData */
     output_rva( "%s", ".L__wine_spec_text" );          /* PointerToRawData */
     output( "\t.long 0\n" );                           /* PointerToRelocations */
     output( "\t.long 0\n" );                           /* PointerToLinenumbers */
-- 
2.27.0

>From 11066801868373edf6ccf60f8127ed6f830850e2 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Fri, 12 Jun 2020 14:11:17 +0200
Subject: [PATCH 21/32] ntdll: Adjust image base to align module.

---
 dlls/ntdll/Makefile.in | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/tools/makedep.c b/tools/makedep.c
index 536d2263e35..3f53fa25ee9 100644
--- a/tools/makedep.c
+++ b/tools/makedep.c
@@ -3285,6 +3285,7 @@ static void output_module( struct makefile *make )
                           strmake( "p$(dlldir)/%s%s", make->module, dll_ext ));
         add_install_rule( make, make->module, strmake( "%s.fake", make->module ),
                           strmake( "d$(dlldir)/fakedlls/%s", make->module ));
+        output( "%s.fake: %s%s\n", module_path, module_path, dll_ext );
         output( "%s%s %s.fake:", module_path, dll_ext, module_path );
     }
     else
